com.fasterxml.jackson.databind.ser.impl

## Class TypeWrappedSerializer

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonSerializer<Object>
  - - com.fasterxml.jackson.databind.ser.impl.TypeWrappedSerializer

All Implemented Interfaces:
  JsonFormatVisitable, ContextualSerializer

    public final class TypeWrappedSerializer
    extends JsonSerializer<Object>
    implements ContextualSerializer

Simple serializer that will call configured type serializer, passing in configured data serializer, and exposing it all as a simple serializer.

### Nested Class Summary

### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonSerializer

`JsonSerializer.None`

### Field Summary

Fields
`protected JsonSerializer<Object>` `_serializer`
`protected TypeSerializer` `_typeSerializer`

### Constructor Summary

Constructors
Constructor and Description
`TypeWrappedSerializer(TypeSerializer typeSer, JsonSerializer<?> ser)`

### Method Summary

All Methods Instance Methods Concrete Methods
`JsonSerializer<?>` `createContextual(SerializerProvider provider, BeanProperty property)` Method called to see if a different (or differently configured) serializer is needed to serialize values of specified property.
`Class<Object>` `handledType()` Method for accessing type of Objects this serializer can handle.
`void` `serialize(Object value, com.fasterxml.jackson.core.JsonGenerator g, SerializerProvider provider)` Method that can be called to ask implementation to serialize values of type this serializer handles.
`void` `serializeWithType(Object value, com.fasterxml.jackson.core.JsonGenerator g, SerializerProvider provider, TypeSerializer typeSer)` Method that can be called to ask implementation to serialize values of type this serializer handles, using specified type serializer for embedding necessary type information.
`TypeSerializer` `typeSerializer()`
`JsonSerializer<Object>` `valueSerializer()`

### Methods inherited from class com.fasterxml.jackson.databind.JsonSerializer

`acceptJsonFormatVisitor, getDelegatee, isEmpty, isEmpty, isUnwrappingSerializer, properties, replaceDelegatee, unwrappingSerializer, usesObjectId, withFilterId, withIgnoredProperties`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### _typeSerializer

    protected final TypeSerializer _typeSerializer

#### _serializer

    protected final JsonSerializer<Object> _serializer

### Constructor Detail

#### TypeWrappedSerializer

    public TypeWrappedSerializer(TypeSerializer typeSer,
                                 JsonSerializer<?> ser)

### Method Detail

#### serialize

    public void serialize(Object value,
                          com.fasterxml.jackson.core.JsonGenerator g,
                          SerializerProvider provider)
                   throws IOException

Description copied from class: `JsonSerializer`
Method that can be called to ask implementation to serialize values of type this serializer handles.

Specified by:
  `serialize` in class `JsonSerializer<Object>`
Parameters:
  `value` - Value to serialize; can not be null.
  `g` - Generator used to output resulting Json content
  `provider` - Provider that can be used to get serializers for serializing Objects value contains, if any.
Throws:
  `IOException`

#### serializeWithType

    public void serializeWithType(Object value,
                                  com.fasterxml.jackson.core.JsonGenerator g,
                                  SerializerProvider provider,
                                  TypeSerializer typeSer)
                           throws IOException

Description copied from class: `JsonSerializer`
Method that can be called to ask implementation to serialize values of type this serializer handles, using specified type serializer for embedding necessary type information.

Default implementation will throw `UnsupportedOperationException` to indicate that proper type handling needs to be implemented.

For simple datatypes written as a single scalar value (JSON String, Number, Boolean), implementation would look like:

      // note: method to call depends on whether this type is serialized as JSON scalar, object or Array!
      typeSer.writeTypePrefixForScalar(value, gen);
      serialize(value, gen, provider);
      typeSer.writeTypeSuffixForScalar(value, gen);

and implementations for type serialized as JSON Arrays or Objects would differ slightly, as `START-ARRAY`/`END-ARRAY` and `START-OBJECT`/`END-OBJECT` pairs need to be properly handled with respect to serializing of contents.

Overrides:
  `serializeWithType` in class `JsonSerializer<Object>`
Parameters:
  `value` - Value to serialize; can not be null.
  `g` - Generator used to output resulting Json content
  `provider` - Provider that can be used to get serializers for serializing Objects value contains, if any.
  `typeSer` - Type serializer to use for including type information
Throws:
  `IOException`

#### handledType

    public Class<Object> handledType()

Description copied from class: `JsonSerializer`
Method for accessing type of Objects this serializer can handle. Note that this information is not guaranteed to be exact -- it may be a more generic (super-type) -- but it should not be incorrect (return a non-related type).

Default implementation will return null, which essentially means same as returning `Object.class` would; that is, that nothing is known about handled type.

Overrides:
  `handledType` in class `JsonSerializer<Object>`

#### createContextual

    public JsonSerializer<?> createContextual(SerializerProvider provider,
                                              BeanProperty property)
                                       throws JsonMappingException

Description copied from interface: `ContextualSerializer`
Method called to see if a different (or differently configured) serializer is needed to serialize values of specified property. Note that instance that this method is called on is typically shared one and as a result method should NOT modify this instance but rather construct and return a new instance. This instance should only be returned as-is, in case it is already suitable for use.

Specified by:
  `createContextual` in interface `ContextualSerializer`
Parameters:
  `provider` - Serializer provider to use for accessing config, other serializers
  `property` - Method or field that represents the property (and is used to access value to serialize). Should be available; but there may be cases where caller cannot provide it and null is passed instead (in which case impls usually pass 'this' serializer as is)
Returns:
  Serializer to use for serializing values of specified property; may be this instance or a new instance.
Throws:
  `JsonMappingException`

#### valueSerializer

    public JsonSerializer<Object> valueSerializer()

#### typeSerializer

    public TypeSerializer typeSerializer()